/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.niederschrift.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="NIEDERSCHRIFT_STATUS_AENDERUNG.DeleteByWahl",
     query="DELETE from NiederschriftStatusAenderung o where o.niederschrift.id IN (SELECT n.id FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet.wahl = ?1)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="NIEDERSCHRIFT_STATUS_AENDERUNG.NiederschriftAndMaxZeitstempel",
     query="select nsa from NiederschriftStatusAenderung nsa where nsa.niederschrift = ?1 and nsa.zeitstempel = ( select max(nsa2.zeitstempel) from NiederschriftStatusAenderung nsa2 where nsa2.niederschrift = ?1 )",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="NIEDERSCHRIFT_STATUS_AENDERUNG.WahlAndMaxZeitstempel",
     query="select nsa from NiederschriftStatusAenderung nsa where nsa.niederschrift.wahldurchfuehrungsgebiet.wahl = ?1 and nsa.zeitstempel = ( select max(nsa2.zeitstempel) from NiederschriftStatusAenderung nsa2 where nsa2.niederschrift = nsa.niederschrift )",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "NIEDERSCHRIFT_STATUS_AENDERUNG")
// @javax.persistence.IdClass(NiederschriftStatusAenderungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class NiederschriftStatusAenderung
extends AbstractNiederschriftStatusAenderung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public NiederschriftStatusAenderung() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public NiederschriftStatusAenderung(NiederschriftStatusAenderung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "niederschrift_status_aender_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "NiederschriftStatusAenderung")
    @javax.persistence.TableGenerator(name = "NiederschriftStatusAenderung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "NiederschriftStatusAenderung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient NiederschriftStatusAenderungPK pkCache;

  @Override
  public NiederschriftStatusAenderungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new NiederschriftStatusAenderungPK(getId());
    }

    return pkCache;
  }

  public static <E extends NiederschriftStatusAenderung> java.util.Map<NiederschriftStatusAenderungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<NiederschriftStatusAenderungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends NiederschriftStatusAenderung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBesitzer = false;
          hasChangedRaum = false;
          hasChangedStatus = false;
          hasChangedZeitstempel = false;
  
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BESITZER", nullable = NiederschriftStatusAenderungConstants.BESITZER_NULLABLE, length=NiederschriftStatusAenderungConstants.BESITZER_MAX_LENGTH)
        
  protected java.lang.String besitzer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBesitzer = false;

  public boolean hasChangedBesitzer(){
    return hasChangedBesitzer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBesitzer = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBesitzer;
  
  /**
   * 
   *
   * getter for NIEDERSCHRIFT_STATUS_AENDERUNG.BESITZER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBesitzer() {
        return besitzer;
      }

  /**
   * 
   *
   * setter for NIEDERSCHRIFT_STATUS_AENDERUNG.BESITZER
   *
   * @param besitzer
   */
  @Override   public void setBesitzer(@javax.annotation.Nullable  java.lang.String besitzer) {

       resetTkCache();
                  
                          java.lang.String besitzerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(besitzer, NiederschriftStatusAenderungConstants.BESITZER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.besitzer
      , besitzerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBesitzer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("besitzer");
      }


             if (!isSeitLadenVeraendertBesitzer) {
          isSeitLadenVeraendertBesitzer = thisAttributChanged;
         if (isSeitLadenVeraendertBesitzer){
           wertNachLadenBesitzer=this.besitzer;
         }
       }
      

       this.besitzer = besitzerInternal;

         }

        
  @javax.persistence.Column(name = "RAUM", nullable = NiederschriftStatusAenderungConstants.RAUM_NULLABLE, length=NiederschriftStatusAenderungConstants.RAUM_MAX_LENGTH)
        
  protected java.lang.String raum =  null;

  @javax.persistence.Transient
  protected boolean hasChangedRaum = false;

  public boolean hasChangedRaum(){
    return hasChangedRaum;
  }
  
  /**
   * 
   *
   * getter for NIEDERSCHRIFT_STATUS_AENDERUNG.RAUM
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getRaum() {
        return raum;
      }

  /**
   * 
   *
   * setter for NIEDERSCHRIFT_STATUS_AENDERUNG.RAUM
   *
   * @param raum
   */
  @Override   public void setRaum(@javax.annotation.Nullable  java.lang.String raum) {

       resetTkCache();
                  
                          java.lang.String raumInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(raum, NiederschriftStatusAenderungConstants.RAUM_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.raum
      , raumInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedRaum |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("raum");
      }


      

       this.raum = raumInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = NiederschriftStatusAenderungConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.niederschrift.entity.NiederschriftStatus status =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.niederschrift.entity.NiederschriftStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for NIEDERSCHRIFT_STATUS_AENDERUNG.STATUS
   */
    @Override   public  de.ivu.elect.business.niederschrift.entity.NiederschriftStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for NIEDERSCHRIFT_STATUS_AENDERUNG.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.niederschrift.entity.NiederschriftStatus status) {

       resetTkCache();
                  de.ivu.elect.business.niederschrift.entity.NiederschriftStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ZEITSTEMPEL", nullable = NiederschriftStatusAenderungConstants.ZEITSTEMPEL_NULLABLE, precision=NiederschriftStatusAenderungConstants.ZEITSTEMPEL_PRECISION)
    
  protected java.util.Date zeitstempel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeitstempel = false;

  public boolean hasChangedZeitstempel(){
    return hasChangedZeitstempel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZeitstempel = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenZeitstempel;
  
  /**
   * 
   *
   * getter for NIEDERSCHRIFT_STATUS_AENDERUNG.ZEITSTEMPEL
   */
    @Override   public  java.util.Date getZeitstempel() {
              if (zeitstempel == null){
            return null;
          } else {
                          return zeitstempel;
          }
      }

  /**
   * 
   *
   * setter for NIEDERSCHRIFT_STATUS_AENDERUNG.ZEITSTEMPEL
   *
   * @param zeitstempel
   */
  @Override   public void setZeitstempel( java.util.Date zeitstempel) {

       resetTkCache();
                  java.util.Date zeitstempelInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(zeitstempel);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeitstempel
      , zeitstempelInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeitstempel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeitstempel");
      }


             if (!isSeitLadenVeraendertZeitstempel) {
          isSeitLadenVeraendertZeitstempel = thisAttributChanged;
         if (isSeitLadenVeraendertZeitstempel){
           wertNachLadenZeitstempel=this.zeitstempel;
         }
       }
      

       this.zeitstempel = zeitstempelInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu Niederschrift
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "NIEDERSCHRIFT_ID", referencedColumnName="NIEDERSCHRIFT_ID"))
  protected de.ivu.elect.business.niederschrift.entity.Niederschrift niederschrift;

  /**
   * 
   */
  @Override
  public void setNiederschrift( de.ivu.elect.business.niederschrift.entity.Niederschrift niederschrift){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (niederschrift == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.niederschrift != null){
            this.niederschrift.removeNiederschriftStatusAenderungByNiederschrift(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          niederschrift.addNiederschriftStatusAenderungByNiederschrift(this);
        }
        this.niederschrift = niederschrift;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setNiederschriftOhneUpdateBeziehung( de.ivu.elect.business.niederschrift.entity.Niederschrift niederschrift){
    resetTkCache();
        this.niederschrift = niederschrift;
    }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.niederschrift.entity.Niederschrift getNiederschrift(){
    return this.niederschrift;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("NiederschriftStatusAenderung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(NiederschriftStatusAenderung other){
                             other.besitzer = this.besitzer;
                                other.raum = this.raum;
                                other.status = this.status;
                                other.zeitstempel = this.zeitstempel;
           
  other.setNiederschrift(this.getNiederschrift());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(NiederschriftStatusAenderung.class)){
        copyEntityAttributesUsingSetter((NiederschriftStatusAenderung) other.castTo(NiederschriftStatusAenderung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von NiederschriftStatusAenderung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(NiederschriftStatusAenderung other){
               other.setBesitzer(this.besitzer);
                  other.setRaum(this.raum);
                  other.setStatus(this.status);
                  other.setZeitstempel(this.zeitstempel);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(NiederschriftStatusAenderung other){
                       if (hasChangedBesitzer) {
        other.setBesitzer(this.besitzer);
      }
                             if (hasChangedRaum) {
        other.setRaum(this.raum);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedZeitstempel) {
        other.setZeitstempel(this.zeitstempel);
      }
             }





    @javax.persistence.Transient
    private transient NiederschriftStatusAenderungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public NiederschriftStatusAenderungTK getNiederschriftStatusAenderungTK(){
    if (tkCache==null) {
    tkCache = new NiederschriftStatusAenderungTK(

getZeitstempel()
,   (getNiederschrift() == null) ? null : getNiederschrift().getNiederschriftTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getNiederschriftStatusAenderungTK();
    }

  @Override
  public NiederschriftStatusAenderungUK getUk(){
    return getNiederschriftStatusAenderungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return NiederschriftStatusAenderung.class;
  }

public NiederschriftStatusAenderungUK getNiederschriftStatusAenderungUK(){

   return  new NiederschriftStatusAenderungUK(



  );
}

  @javax.persistence.Transient
  private transient NiederschriftStatusAenderungProperties properties;

  public NiederschriftStatusAenderungProperties getProperties(){
    if (properties == null) {
      properties = new NiederschriftStatusAenderungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public NiederschriftStatusAenderungProperties getNiederschriftStatusAenderungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return NiederschriftStatusAenderungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(NiederschriftStatusAenderungConstants.MESSAGE_KEY_BESITZER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NiederschriftStatusAenderungConstants.MESSAGE_KEY_BESITZER_EINZAHL);

        besitzer =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(NiederschriftStatusAenderungConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NiederschriftStatusAenderungConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.niederschrift.entity.NiederschriftStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL);

        zeitstempel =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBesitzer) {
      result.put(NiederschriftStatusAenderungConstants.MESSAGE_KEY_BESITZER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBesitzer , besitzer));
    }
                                                if (isSeitLadenVeraendertStatus) {
      result.put(NiederschriftStatusAenderungConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertZeitstempel) {
      result.put(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenZeitstempel , zeitstempel));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBesitzer = false;
      wertNachLadenBesitzer = null;
                                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertZeitstempel = false;
      wertNachLadenZeitstempel = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "NIEDERSCHRIFT_STATUS_AENDERUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "NiederschriftStatusAenderung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(NiederschriftStatusAenderungConstants.BESITZER_MAX_LENGTH ,  besitzer, this, NiederschriftStatusAenderungConstants.MESSAGE_KEY_BESITZER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(NiederschriftStatusAenderungConstants.RAUM_MAX_LENGTH ,  raum, this, NiederschriftStatusAenderungConstants.MESSAGE_KEY_RAUM_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, NiederschriftStatusAenderungConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zeitstempel, this, NiederschriftStatusAenderungConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
